#ifdef GL_ES
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform float u_ctime;
uniform float u_threshold;
// uniform float u_radius;
uniform vec4  u_outlineColor;

void main(void)
{
  float radius = 5.0;   // u_radius; <== Tegra 2/3/4 error

  vec4 accum  = vec4(0.0);
  vec4 normal = vec4(0.0);

  normal = texture2D(CC_Texture0, v_texCoord);
  normal.rgb = vec3(1.0, 1.0, 1.0);
  for(float i = 1.0; i <= radius; i += 1.0) {
    accum += texture2D(CC_Texture0, vec2(v_texCoord.x - 0.002 * i, v_texCoord.y - 0.002 * i));
    accum += texture2D(CC_Texture0, vec2(v_texCoord.x + 0.002 * i, v_texCoord.y - 0.002 * i));
    accum += texture2D(CC_Texture0, vec2(v_texCoord.x + 0.002 * i, v_texCoord.y + 0.002 * i));
    accum += texture2D(CC_Texture0, vec2(v_texCoord.x - 0.002 * i, v_texCoord.y + 0.002 * i));
    accum += texture2D(CC_Texture0, vec2(v_texCoord.x, v_texCoord.y - 0.002 * i));
    accum += texture2D(CC_Texture0, vec2(v_texCoord.x + 0.002 * i, v_texCoord.y));
    accum += texture2D(CC_Texture0, vec2(v_texCoord.x, v_texCoord.y + 0.002 * i));
    accum += texture2D(CC_Texture0, vec2(v_texCoord.x - 0.002 * i, v_texCoord.y));
  }

  accum.rgb =  u_outlineColor.rgb * u_outlineColor.a * accum.a * 0.95;
  float opacity = ((1.0 - normal.a) / radius) * (u_ctime / u_threshold);

  normal = (accum * opacity) + (normal * normal.a);
  gl_FragColor = v_fragmentColor * normal;
}