#ifdef GL_ES
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
uniform vec2 v_texCoordMask;

uniform sampler2D u_textureMask;
uniform vec2  u_maskPos;

void main(void)
{
  vec4 normal = texture2D(CC_Texture0, v_texCoord);
  if (normal.a == 0.0) {
    gl_FragColor = vec4(0.0);
  }
  else {
    vec4 mask = texture2D(u_textureMask, vec2(v_texCoord.x + u_maskPos.x, v_texCoord.y + u_maskPos.y));
    gl_FragColor = v_fragmentColor * mix(mask, normal, mask.a);
  }
}