#ifdef GL_ES
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#endif

varying vec4  v_fragmentColor;
varying vec2  v_texCoord;

uniform vec2  resolution;
uniform float noiseDepth;

float rand(vec2 co)
{
  float a = fract(dot(co.xy, vec2(2.067390879775102, 12.451168662908249))) - 0.5;
  float s = a * (6.182785114200511 + a*a * (-38.026512460676566 + a*a * 53.392573080032137));
  return abs(fract(s * 43758.5453));
}

void main()
{
  float time = CC_Time[1];

  float ux = 1./resolution.x*cos(time*3.)*9.;
  float uy = 1./resolution.y*sin(time*3.)*5.;
  float uz = 1./resolution.x*sin(time*3.)*7.;

  float r = texture2D(CC_Texture0, vec2(v_texCoord.x-ux, v_texCoord.y-uy)).r;
  float g = texture2D(CC_Texture0, vec2(v_texCoord.x+uz, v_texCoord.y   )).g;
  float b = texture2D(CC_Texture0, vec2(v_texCoord.x+uy, v_texCoord.y+uy)).b;

  vec2 uv = floor(gl_FragCoord.xy/resolution.xy*1000.)/2.;
  vec3 noise = mix(vec3(r,g,b), vec3(rand(uv*abs(sin(time)))), noiseDepth);
  gl_FragColor = vec4(noise, 1.0);
}
